//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#include "sb_Barge.h"

sb_Barge::sb_Barge()
{
	x = 0;
	y = 0;
	r = 1.0f;
	g = 1.0f;
	b = 1.0f;
	a = 0.6f;
	rotation = 0.0f;
	active = false;
}

void sb_Barge::init(sb_ShieldGridPtr relatedShieldGrid)
{
	pGrid = relatedShieldGrid;
	
	//set up rangeSector array
	//will hold offsets for sectors that fall into short Range of this Barge
	//looks like this:  ('.' is at the center)
	//     ##
	//   ######
	//  ########
    // ##########
    // ##########
	//#####.######
	//############
	// ##########
	// ##########
	//  ########
	//   ######
	//     ##
	int i, iWas;
	float dx, dy;
	
	i=0;
	dx = 0; dy = -5;
	rangeSector[i].dx = dx; rangeSector[i].dy = dy;
	i++;
	dx = 1; dy = -5;
	rangeSector[i].dx = dx; rangeSector[i].dy = dy;
	i++;
	dx = -2; dy = -4; //next row
	iWas = i;
	for (i=iWas; i < iWas+6; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -3; dy = -3; //next row
	iWas = i;
	for (i=iWas; i < iWas+8; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -4; dy = -2; //next row
	iWas = i;
	for (i=iWas; i < iWas+10; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;	
	}
	//i has been increased one more in for loop
	dx = -4; dy = -1; //next row
	iWas = i;
	for (i=iWas; i < iWas+10; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -5; dy = 0; //next row
	iWas = i;
	for (i=iWas; i < iWas+12; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//*bottom half now
	//i has been increased one more in for loop
	dx = -5; dy = 1; //next row
	iWas = i;
	for (i=iWas; i < iWas+12; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -4; dy = 2; //next row
	iWas = i;
	for (i=iWas; i < iWas+10; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -4; dy = 3; //next row
	iWas = i;
	for (i=iWas; i < iWas+10; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -3; dy = 4; //next row
	iWas = i;
	for (i=iWas; i < iWas+8; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = -2; dy = 5; //next row
	iWas = i;
	for (i=iWas; i < iWas+6; i++)
	{
		rangeSector[i].dx = dx; rangeSector[i].dy = dy;
		dx++;
	}
	//i has been increased one more in for loop
	dx = 0; dy = 6; //last row
	rangeSector[i].dx = dx; rangeSector[i].dy = dy;
	i++;
	dx = 1; dy = 6;
	rangeSector[i].dx = dx; rangeSector[i].dy = dy;
}

void sb_Barge::animate()
{
	//the barge doesn't currently animate
}

void sb_Barge::draw()
{	
	//vertex points in the outline of the sb_Barge
	float thePoints[] = {
		4,-16, 
		8, -12, 
		8, -4, 
		12, -4,
		12, -8,
		16, -8,
		16, 12,
		12, 12,
		12, 8,
		8, 8,
		8, 12,
		6, 14,
		4, 14,
		4, 12,
		-4, 12,
		-4, 14,
		-6,14,
		-8, 12,
		-8,8,
		-12, 8,
		-12, 12,
		-16, 12,
		-16,-8,
		-12, -8,
		-12, -4,
		-8, -4,
		-8, -12,
		-4, -16,
		4,-16,
		-2000, -2000
	};
	
	glAAFlush();
	glLoadIdentity();
	glTranslatef( x, y, 0.0f );
	glRotatef( rotation, 0.0f, 0.0f, 1.0f );
	
	if (active) glAAColor4f(r,g,b,a);
	else glAAColor4f(r,g,CLAMP(b+0.3f, 0.0, 1.0f),CLAMP(a-0.3f, 0.1f, 1.0f));
	
	glAALineWidth(2.0f);
	
	glAABegin(GL_LINE_STRIP);
	int i;
	i = 0;
	while ( thePoints[i] != -2000 )
	{
		glAAVertex2f( thePoints[i], thePoints[i+1] );
		i += 2;
	}
	glAAEnd();
}

void sb_Barge::moveTo(float newX, float newY)
{
	x = newX;
	y = newY;
}

void sb_Barge::setRotation(float degrees)
{
	rotation = degrees;
}

void sb_Barge::rotate(float degrees)
{
	float tempRotation;
	tempRotation = rotation + degrees;
	if (tempRotation >= 360.0f)
	{
		rotation = tempRotation - 360;
	}
	else if (tempRotation <= 0.0f)
	{
		rotation = 360 + tempRotation;
	}
	else
	{
		rotation = tempRotation;
	}
}

void sb_Barge::setColor(float red, float green, float blue, float alpha)
{
	r = CLAMP(red, 0.0f, 1.0f);
	g = CLAMP(green, 0.0f, 1.0f);
	b = CLAMP(blue, 0.0f, 1.0f);
	a = CLAMP(alpha, 0.0f, 1.0f);
}

/* fitIntoGrid()
   important: this can fail (return false) Where a barge can go is heavily
              restricted so it should always be tested to make sure it
			  made it in.
*/
int sb_Barge::fitIntoGrid()
{
	sb_point cornerSector;
	cornerSector = pGrid->sectorPointOnDot((int)(x - 1.0f), (int)(y -1.0f));
	if (cornerSector.x == -1) //if the point is not in the grid
	{
		return false; //we can't fit it in the grid so return false
	}
	//Now we need to test for other reasons it can't fit
	//if it is too close to edge to put standard shield square around it.
	if (cornerSector.x < 3 || cornerSector.y < 3 
		|| cornerSector.x > pGrid->getXSectors() - 5
		|| cornerSector.y > pGrid->getYSectors() - 5)
	{
		return false;
	}
	//if part of the 2x2 square of the barge is over the outOfRange area
	if (pGrid->getSectorValue((int)cornerSector.x, (int)cornerSector.y) == kST_outOfRange ||
		pGrid->getSectorValue((int)cornerSector.x+1, (int)cornerSector.y) == kST_outOfRange ||
		pGrid->getSectorValue((int)cornerSector.x, (int)cornerSector.y+1) == kST_outOfRange ||
		pGrid->getSectorValue((int)cornerSector.x+1, (int)cornerSector.y+1) == kST_outOfRange )
	{
		return false;
	}
	//if another barge (or other object) is within range
	int i;
	sb_SectorType thisSectorType;
	for (i=0; i<totalRangeSectors; i++)
	{
		thisSectorType = pGrid->getSectorValue((int)(cornerSector.x + rangeSector[i].dx), 
											   (int)(cornerSector.y + rangeSector[i].dy));
		if (thisSectorType == kST_activeObject || thisSectorType == kST_inactiveObject )
		{
			return false;
		}
	}
	//*at this point it passed all the tests and it can be fit in
	//set the range around the barge to be vacant (not outOfRange)
	for (i=0; i < totalRangeSectors; i++)
	{
		pGrid->setSector((int)(cornerSector.x + rangeSector[i].dx), 
						 (int)(cornerSector.y + rangeSector[i].dy),
						 kST_vacant);
	}
	
	//set the shieldGrid to have an activeObject under where the barge fits in (a 2x2 grid)
	pGrid->setSector((int)cornerSector.x, (int)cornerSector.y, kST_inactiveObject ); //all barges start inactive
	pGrid->setSector((int)cornerSector.x+1, (int)cornerSector.y, kST_inactiveObject );
	pGrid->setSector((int)cornerSector.x, (int)cornerSector.y+1, kST_inactiveObject );
	pGrid->setSector((int)cornerSector.x+1, (int)cornerSector.y+1, kST_inactiveObject );
	
	//place pixel coordinate of barge at the center of the 2x2 grid
	x = (cornerSector.x+1) * pGrid->getSectorSize();
	y = (cornerSector.y+1) * pGrid->getSectorSize();
	
	return true;
}

int sb_Barge::fitIntoGrid( float dotX, float dotY )
{
	float oldX, oldY;
	moveTo(dotX, dotY);
	if (fitIntoGrid())
	{
		return true;
	}
	else
	{
		moveTo(oldX, oldY);
		return false;
	}
}

int sb_Barge::pointIsInBarge(float dotX, float dotY )
{
	int sectorSize = pGrid->getSectorSize();
	if (dotX > x-sectorSize && dotX < x+sectorSize
        && dotY > y-sectorSize && dotY < y+sectorSize)
	{
		return true;
	}
	else
	{
		return false;
	}
}

float sb_Barge::getX()
{
	return x;
}

float sb_Barge::getY()
{
	return y;
}
int sb_Barge::isActive()
{
	return active;
}

void sb_Barge::makeInactive()
{
	active = false;
}

void sb_Barge::makeActive()
{
	active = true;
}