//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_BARGE_H
#define SB_BARGE_H

#include "sb_global.h"
#include "sb_ShieldGrid.h"

class sb_Barge
{
public:
	sb_Barge();
	
	void init( sb_ShieldGridPtr relatedShieldGrid );
	
	void animate();
	void draw();
	
	void moveTo(float newX, float newY);
	void setRotation(float degrees);
	void rotate(float degrees);
	//void pointAt(float targetX, float targetY);
	void setColor(float red, float green, float blue, float alpha);
	
	int fitIntoGrid();
	int fitIntoGrid( float dotX, float dotY );
	int pointIsInBarge(float dotX, float dotY );
	
	float getX();
	float getY();
	int isActive();
	void makeInactive();
	void makeActive();
	
private:
	float x, y;
	float r, g, b, a;
	float rotation;
	sb_ShieldGridPtr pGrid; //pointer to shieldGrid so we can interact with it
	static const int totalRangeSectors = 96;
	sb_vector rangeSector[totalRangeSectors]; //will hold offsets for sectors that fall into short Range of this Barge
	
	int active;
};

#endif