//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#include "sb_Circle.h"

sb_Circle::sb_Circle()
{
    x = 0.0f;
    y = 0.0f;
    radius = 1.0f;
}

sb_Circle::sb_Circle( float newX, float newY, float newRadius )
{
    x = newX;
    y = newY;
    radius = newRadius;
}

void sb_Circle::init( float newX, float newY, float newRadius )
{
    x = newX;
    y = newY;
    radius = newRadius;
}

void sb_Circle::moveTo( float newX, float newY )
{
	x = newX;
	y = newY;
}

void sb_Circle::setX( float newX )
{
    x = newX;
}

void sb_Circle::setY( float newY )
{
    y = newY;
}

void sb_Circle::setRadius( float newRadius )
{
    radius = newRadius;
}

float sb_Circle::getX()
{
    return x;
}

float sb_Circle::getY()
{
    return y;
}

float sb_Circle::getRadius()
{
    return radius;
}

float sb_Circle::distanceFrom ( sb_Circle anotherCircle )
{
    float xd = anotherCircle.getX() - x; 
    float yd = anotherCircle.getY() - y;
    return frsqrtes_nr(xd*xd + yd*yd) - anotherCircle.getRadius() - radius; //frsqrtes_nr is from AAUtilities.h
    
}

float sb_Circle::distanceFrom ( float pointX, float pointY )
{
    float xd = pointX - x; 
    float yd = pointY - y;
    return frsqrtes_nr(xd*xd + yd*yd) - radius; //frsqrtes_nr is from AAUtilities.h
}

float sb_Circle::distanceOfCenterFrom ( sb_Circle anotherCircle )
{
    float xd = anotherCircle.getX() - x; 
    float yd = anotherCircle.getY() - y;
    return frsqrtes_nr(xd*xd + yd*yd) - anotherCircle.getRadius() ; //frsqrtes_nr is from AAUtilities.h
}

float sb_Circle::distanceOfCenterFrom ( float pointX, float pointY )
{
    float xd = pointX - x; 
    float yd = pointY - y;
    return frsqrtes_nr(xd*xd + yd*yd); //frsqrtes_nr is from AAUtilities.h
}

int sb_Circle::isInContactWith( sb_Circle anotherCircle )
{
    float combinedRadii;
    float xd = anotherCircle.getX() - x; 
    float yd = anotherCircle.getY() - y;
    
    combinedRadii = anotherCircle.getRadius() + radius;
    
    if ( (xd*xd + yd*yd) < combinedRadii*combinedRadii ) // square combinedRadii to avoid calculating square root
    {
        return true;
    }
    else
    {
        return false;
    }
}

int sb_Circle::isInContactWith( float pointX, float pointY )
{
    float xd = pointX - x; 
    float yd = pointY - y;
    
    if ( (xd*xd + yd*yd) < radius*radius ) // square radius to avoid calculating square root
    {
        return true;
    }
    else
    {
        return false;
    }
}
/*


    float distanceFrom ( sb_Circle anotherCircle );
    float distanceFrom ( float x, float y );
    float distanceOfCenterFrom ( sb_Circle anotherCircle );
    float distanceOfCenterFrom ( float x, float y );
        int isInContactWith ( sb_Circle anotherCircle );
private:
        float x, y, radius;
    */