//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_CIRCLE_H
#define SB_CIRCLE_H

#include "AAUtilities.h"

class sb_Circle
{
public:
    sb_Circle();
    sb_Circle( float newX, float newY, float newRadius );
    
    void init( float newX, float newY, float newRadius );
    
	void moveTo( float newX, float newY );
    void setX( float newX );
    void setY( float newY );
    void setRadius( float newRadius );
    
    float getX();
    float getY();
    float getRadius();
    
    float distanceFrom ( sb_Circle anotherCircle );
    float distanceFrom ( float x, float y );
    float distanceOfCenterFrom ( sb_Circle anotherCircle );
    float distanceOfCenterFrom ( float x, float y );
    
    int isInContactWith ( sb_Circle anotherCircle );
    int isInContactWith ( float pointX, float pointY );
    
private:
    float x, y, radius;
};

#endif