//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_DESTROYERCONTROL_H
#define SB_DESTROYERCONTROL_H

#include "sb_global.h"
#include "sb_Destroyer.h"
#include "sb_MissileControl.h"
#include "sb_ShieldGrid.h"
#include "RNG.h"

struct sb_line
{
	sb_point begin;
	sb_point end;
};

class sb_DestroyerControl
{
public:
	sb_DestroyerControl();
	void reset();
	void init( sb_line newEntranceBorder, sb_vector newAdvanceVector, sb_ShieldGridPtr newGrid );
	int launch( int numberToLaunch ); //eventually the type of the destroyer would be an argument here
	
	void animate( Uint32 ticksPassed );
	void draw();
	
	void go();
	void stop();
	int isStopped();

	sb_Circle getNextCollisionCircle(int &destroyerId);
	void damage(int destroyerId);
	
	int allInactive();
	
private:
	int destroyersAvailable();
	int collidesWithOthers( int indexOfDestroyer );
		
	static const int totalDestroyers = 30;
	sb_Destroyer d[totalDestroyers];
	
	sb_line enterBorder;
	sb_vector advanceVector;
	
	int currentDestroyer;
	
	sb_ShieldGridPtr grid;
	sb_MissileControl missiles;

	int stopping;
	int stopped;
	
	RNG rng;
};

#endif