//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#include "sb_Game.h"

sb_Game::sb_Game()
{
	firstRelativeRead = false;
	
	rng.init(SDL_GetTicks()); //seed the random number generator
	
	musicBox.load("data/Title.ogg", kMusic_title);
	musicBox.load("data/Battle.ogg", kMusic_battle);
	musicBox.load("data/Countdown.ogg", kMusic_countdown);
	musicBox.load("data/LevelComplete.ogg", kMusic_levelComplete);
    musicBox.load("data/Gameover.ogg", kMusic_gameover);
	
	noisemaker.load("data/soundfx/buzz.aiff", kFX_buzz);
	noisemaker.load("data/soundfx/missileHit.aiff", kFX_missileHit);
	noisemaker.load("data/soundfx/missileBlast.aiff", kFX_missileBlast);
	noisemaker.load("data/soundfx/missileFail.aiff", kFX_click);
	noisemaker.load("data/soundfx/missile.aiff", kFX_playerMissile);
	noisemaker.load("data/soundfx/SBTactical1.ogg", kFX_tactical1);
	noisemaker.load("data/soundfx/SBTactical2.ogg", kFX_tactical2);
	noisemaker.load("data/soundfx/SBTactical3.ogg", kFX_tactical3);
	noisemaker.load("data/soundfx/SBTactical4.ogg", kFX_tactical4);
	noisemaker.load("data/soundfx/shieldSection.aiff", kFX_shieldSection);
	noisemaker.load("data/soundfx/shieldBarrier.aiff", kFX_shieldBarrier);
	//noisemaker.load("data/soundfx/timer.ogg", kFX_timer);
	//noisemaker.load("data/soundfx/lose.ogg", kFX_lose);
	
	stageLayout = 1;  // 1: us|them, 2: them|us, 3:  us above them, 4: them above us, 5: us/them, 6: them/us 
	totalEnclosures = 0;
	
	//initialize barges
	int i;
	for (i=0; i<totalBarges; i++)
	{
		barge[i].init( &grid );
	}
	
	//initialize guns
	for (i=0; i<totalGuns; i++)
	{
		gun[i].init( &grid );
	}
	indexOfLastGun = -1;
	
	enemyAdvanceVector.dx = 0.0f;
	enemyAdvanceVector.dy = -1.0f;
	
	reset();
	
	ticksNow = SDL_GetTicks();
}

sb_Game::~sb_Game()
{
	
}

void sb_Game::reset()
{
	gameover = false;
	newStage = false;
	newWave = false;
	currentWave = 1;
	currentLevel = 1;
	grid.reset();
	playerMissiles.reset();
	destroyers.reset();
}

void sb_Game::preEvent()
{
	pointerRelX = 0;
	pointerRelY = 0;
}

void sb_Game::processEvent( SDL_Event &event )
{
	if  (event.type == SDL_MOUSEMOTION )
	{
		pointerX = event.motion.x;
		pointerY = event.motion.y;
		
		pointerRelX = event.motion.xrel;
		pointerRelY = event.motion.yrel;  
		
		if (firstRelativeRead == false)
		{
			firstRelativeRead = true;
			pointerRelX = 0;
			pointerRelY = 0;
		}
	}

	
}

Uint32 sb_Game::updateTicksPassed()
{
	ticksNow = SDL_GetTicks();
	ticksSinceLastUpdate = ticksNow - ticksAtLastUpdate;
	ticksAtLastUpdate = ticksNow;
	
	return ticksAtLastUpdate;
}

Uint32 sb_Game::getTicksPassed()
{
	return ticksSinceLastUpdate;
}