//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_GAME_H
#define SB_GAME_H

#include "sb_global.h"
#include "sb_musicBox.h"
#include "sb_Noisemaker.h"
#include "sb_ShieldGrid.h"
#include "sb_Barge.h"
#include "sb_Gun.h"
#include "sb_MissileControl.h"
#include "sb_DestroyerControl.h"


#define kMusic_title 0
#define kMusic_battle 1
#define kMusic_countdown 2
#define kMusic_levelComplete 3
#define kMusic_gameover 4


#define kFX_buzz 0
#define kFX_missileHit 1
#define kFX_missileBlast 2
#define kFX_click 3
#define kFX_playerMissile 4
#define kFX_tactical1 5
#define kFX_tactical2 6
#define kFX_tactical3 7
#define kFX_tactical4 8
#define kFX_shieldSection 9
#define kFX_shieldBarrier 10
#define kFX_timer 11
#define kFX_lose 12

class sb_Game
{
public:
	sb_Game();
	~sb_Game();
	
	void reset();
	void preEvent();
	void processEvent( SDL_Event &event );
	Uint32 updateTicksPassed();
	Uint32 getTicksPassed();
	
	sb_MusicBox musicBox;
	sb_Noisemaker noisemaker;
	
	RNG rng; //random number generator
	
	sb_ShieldGrid grid;
	int stageLayout; // 1: us|them, 2: them|us, 3:  us above them, 4: them above us, 5: us/them, 6: them/us, 7: us\them, 8: them\us
	static const int totalBarges = 5;
	sb_Barge barge[totalBarges];
	static const int totalGuns = 100;
	sb_Gun gun[totalGuns];
	int indexOfLastGun;
	sb_MissileControl playerMissiles;
	
	int totalEnclosures;
	
	sb_vector enemyAdvanceVector; //depending on stage layout the direction enemy moves in to approach player
	sb_line enemyBorder;
	sb_DestroyerControl destroyers;
	
	//pointer position: *important: these are only updated when processEvent is called!
	Sint32 pointerX, pointerY; 
	Sint32 pointerRelX, pointerRelY; //change in pointer position
	
	int currentLevel;
	int currentWave;
	
	int gameover;
	int newStage;
	int newWave;
	
private:
	Uint32 ticksNow;
	Uint32 ticksAtLastUpdate;
	Uint32 ticksSinceLastUpdate;
	int firstRelativeRead;
};

typedef sb_Game* sb_GamePtr;

#endif