//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_GAMEPHASE_H
#define SB_GAMEPHASE_H

#include "sb_Game.h"
#include "sb_global.h"

class sb_GamePhase
{
public:
	sb_GamePhase( sb_GamePtr gameToUse );
    virtual ~sb_GamePhase() = 0;
	

	virtual void start() = 0;
	virtual void pause() = 0;
	virtual void end() = 0;
    virtual void reset() = 0;
	virtual void processEvent( SDL_Event &event ) = 0;
    virtual void animate() = 0;
	virtual void draw() = 0;
	int isDone();
	
protected:
    int done;
	sb_GamePtr game;
};

typedef sb_GamePhase* sb_GamePhasePtr;

#endif