//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_GUN_H
#define SB_GUN_H

#include "sb_global.h"
#include "sb_ShieldGrid.h"

class sb_Gun
{
public:
	sb_Gun();
	
	void init( sb_ShieldGridPtr relatedShieldGrid );
	
	void animate( Uint32 ticks );
	void draw();
	void drawSquareInGrid();
	
	void moveTo(float newX, float newY);
	void setRotation(float degrees);
	void rotate(float degrees);
	//void pointAt(float targetX, float targetY);
	void setColor(float red, float green, float blue, float alpha);
	
	int isActive();
	int isReloading();
	void makeInactive();
	void makeActive();

	float getRotation();
	
	void reload();
	int fitIntoGrid();
	int fitIntoGrid( float dotX, float dotY );
	int pointIsInside(float dotX, float dotY );
	
	float getX();
	float getY();
	
private:
	float x, y;
	float r, g, b, a;
	float rotation;
	float scale;
	sb_ShieldGridPtr pGrid; //pointer to shieldGrid so we can interact with it

	int inGame;
	int active;
	int reloading;
	Sint32 reloadTimeRemaining;
	
};

#endif