//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_MISSILE_H
#define SB_MISSILE_H

#include "sb_global.h"
#include "sb_Circle.h"

class sb_Missile
{
public:
    sb_Missile();
	
    void launch(float newTargetX, float newTargetY);
    int isActive();
    int isExploding();
    
    void animate( Uint32 ticksPassed );
    void draw();
    
    void moveTo( float newX, float newY );
    void setRotation( float newRotation );
    void rotate( float degrees );
    void setSpeed( float newSpeed );
	void setColor(float red, float green, float blue, float alpha);
	
	sb_Circle getBlastCircle();
	int needToPlayExplodeSound();
	
	void makeInactive();
	
private:
    float x, y;
    float originX, originY;
    float targetX, targetY;
	float forceX, forceY;
	float rotation;
	float rotationSpeed;
    float speed;
    sb_Circle blast;
	
	Uint32 time;
	
	float r, g, b, a;
	
	int active; //missile is being used (either launched, exploding or fading)
	int exploding; //missile hit target and is exploding
	int fading; //all that remains is the trail
	
	int needToPlaySound;
	
	static const int totalTrailPoints = 100;
	sb_point trailPoint[totalTrailPoints];
	int trailEnd;
	int onStraightTrail;
	int trailIsFading;
	float trailAlpha;
    
    float angleToTarget(); //find correct rotation to point at target point
	void drawTrail();
};

#endif