//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#include "sb_MissileControl.h"

sb_MissileControl::sb_MissileControl()
{

}

void sb_MissileControl::reset()
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		m[i].makeInactive();
	}
}

int sb_MissileControl::launch(float x, float y, float rotation, float targetX, float targetY, int tech)
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isActive() == false)
		{
			m[i].setRotation(rotation);
			m[i].moveTo(x,y);
			m[i].launch(targetX, targetY);
			//tech is ignored for now
			return true;
		}
	}
	//if we got here all missiles are already active
	return false;
}

void sb_MissileControl::animate( Uint32 ticksPassed )
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isActive())
		{
			m[i].animate( ticksPassed );
		}
	}
		
}

void sb_MissileControl::draw()
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isActive())
		{
			m[i].draw();
		}
	}
	
}

int sb_MissileControl::anyCollisionWith( sb_Circle enemy )
{
	int i;
	sb_Circle thisMissileCircle;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isExploding())
		{
			thisMissileCircle = m[i].getBlastCircle();
			if (thisMissileCircle.isInContactWith( enemy ))
			{
				return true;
			}
		}
	}
	//if we get here there were no collisions with the enemy that was passed
	return false;
}

int sb_MissileControl::anyCollisionWith( float enemyX, float enemyY)
{
	int i;
	sb_Circle thisMissileCircle;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isExploding())
		{
			thisMissileCircle = m[i].getBlastCircle();
			if (thisMissileCircle.isInContactWith( enemyX, enemyY ))
			{
				return true;
			}
		}
	}
	//if we get here there were no collisions with the enemy that was passed
	return false;
}

int sb_MissileControl::allInactive()
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].isActive())
		{
			return false;
		}
	}
	return true;
}

int sb_MissileControl::explodeSound()
{
	int i;
	for (i=0; i < totalMissiles; i++)
	{
		if (m[i].needToPlayExplodeSound())
		{
			return true;
		}
	}
	return false;
}

void sb_MissileControl::setColor(float red, float green, float blue, float alpha)
{
	int i;
	for (i=0; i<totalMissiles; i++)
	{
		m[i].setColor(red, green, blue, alpha);
	}
}