//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_MISSILECONTROL_H
#define SB_MISSILECONTROL_H

#include "sb_Missile.h"

class sb_MissileControl
{
public:
	sb_MissileControl();
	void reset();
	
	int launch(float x, float y, float rotation, float targetX, float targetY, int tech);

	void animate( Uint32 ticksPassed );
	void draw();
	
	int anyCollisionWith( sb_Circle enemy );
	int anyCollisionWith( float enemyX, float enemyY );
	
	int allInactive();
	int explodeSound();
	
	void setColor(float red, float green, float blue, float alpha);
	
private:
	static const int totalMissiles = 50;
	sb_Missile m[totalMissiles];
};

#endif