//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#include "sb_MusicBox.h"
#include <iostream.h>

sb_MusicBox::sb_MusicBox()
{	
	int rate = SB_DEFAULT_SOUND_RATE;
    Uint16 format = MIX_DEFAULT_FORMAT;
    int channels = SB_DEFAULT_SOUND_CHANNELS;
    int buffers = SB_DEFAULT_SOUND_BUFFERS;
	
/*	int frq, ch;  //these would be used to get information about the current Audio Device settings, but when sent
	Uint16 fmt;   //to Mix_QuerySpec(). We won't use the returned values, though, we just want to know if it fails.
					  

	if (!Mix_QuerySpec( &frq, &fmt, &ch ) ) //if the Audio device has not been opened yet, let's open it.
	{*/
		if(Mix_OpenAudio(rate, format, channels, buffers)) //open the device with our settings
		{
			cout << ("Unable to open audio! (in sb_MusicBox)\n");
		}
	//}

	int i;
	for (i=0; i<SB_PLAYLISTMAX; i++)
	{	
		music[i] = NULL;
	}	
}

sb_MusicBox::~sb_MusicBox()
{
	stop();
	int i;
	for(i=0; i<5; i++)
	{
		free(i);
	}

	Mix_CloseAudio();
}

void sb_MusicBox::load(char * musicFilepath)
{
	if (music[0] != NULL)
	{
		free();
	}
	music[0] = Mix_LoadMUS(musicFilepath);
}

void sb_MusicBox::load(char * musicFilepath, int playlistNumber)
{
	if (playlistNumber >= 0 && playlistNumber < SB_PLAYLISTMAX)
	{
		if (music[playlistNumber] != NULL)
		{
			free(playlistNumber);
		}
		music[playlistNumber] = Mix_LoadMUS(musicFilepath);
	}
}

void sb_MusicBox::play()
{
	if (Mix_PlayingMusic())
	{
		stop();
	}
	Mix_PlayMusic(music[0], -1); //-1 means continuously loop
	playing = 0;
	//Mix_HookMusicFinished(stop()); //can't seem to get the hook to work from within a class
}

void sb_MusicBox::play(int playlistNumber)
{
	if (Mix_PlayingMusic())
	{
		stop();
	}
	playing = playlistNumber;
	Mix_PlayMusic(music[playlistNumber], -1); //-1 means continuously loop
	//Mix_HookMusicFinished(this->stop()); //can't seem to get the hook to work from within a class
}

void sb_MusicBox::playOnce()
{
	if (Mix_PlayingMusic())
	{
		stop();
	}
	Mix_PlayMusic(music[0], 0); //0 means loop zero times (play once)
	playing = 0;
	//Mix_HookMusicFinished(stop()); //can't seem to get the hook to work from within a class
}

void sb_MusicBox::playOnce(int playlistNumber)
{
	if (Mix_PlayingMusic())
	{
		stop();
	}
	playing = playlistNumber;
	Mix_PlayMusic(music[playlistNumber], 0); //0 means loop zero times (play once)
	//Mix_HookMusicFinished(this->stop()); //can't seem to get the hook to work from within a class
}

void sb_MusicBox::pause()
{
	if(!Mix_PausedMusic())
	{
		Mix_PauseMusic();
	}
}

void sb_MusicBox::unpause()
{
	if(Mix_PausedMusic())
	{
		Mix_ResumeMusic();
	}
}

void sb_MusicBox::pauseToggle()
{
	if(Mix_PausedMusic())
	{
		Mix_ResumeMusic();
	}
	else
	{
		Mix_PauseMusic();
	}
}

void sb_MusicBox::stop()
{
	playing = -1;
	Mix_HaltMusic();
}

void sb_MusicBox::fadeOut()
{
	//3 second fade by default
	Mix_FadeOutMusic(3000);
}

void sb_MusicBox::fadeOut(int milliseconds)
{
	Mix_FadeOutMusic(milliseconds);
}

void sb_MusicBox::free()
{
	if (music[0] != NULL)
	{
		if (playing == 0)
		{
			stop();
		}
		Mix_FreeMusic(music[0]);
		music[0] = NULL;
	}
}

void sb_MusicBox::free(int playlistNumber)
{
	if (playlistNumber >= 0 && playlistNumber < SB_PLAYLISTMAX)
	{
		if (music[playlistNumber] != NULL)
		{
			if (playing == playlistNumber)
			{
				stop();
			}
			Mix_FreeMusic(music[playlistNumber]);
			music[playlistNumber] = NULL;
		}
	}
}

int sb_MusicBox::isPlaying()
{
	return (Mix_PlayingMusic());
}

int sb_MusicBox::isFadingOut()
{
	return (Mix_FadingMusic() == MIX_FADING_OUT);
}