//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_MUSICBOX_H
#define SB_MUSICBOX_H

#include "SDL_Mixer.h"
#include "sb_global.h"

#define SB_PLAYLISTMAX 8

class sb_MusicBox
{
public:
	sb_MusicBox();
	~sb_MusicBox();

	void load(char * musicFilepath);
	void load(char * filepath, int playlistNumber);
	void play();
	void play(int playlistNumber);
	void playOnce();
	void playOnce(int playlistNumber);
	void pause();
	void unpause();
	void pauseToggle();
	void stop();
	void fadeOut();
	void fadeOut(int milliseconds);
	void free();
	void free(int playlistNumber);
	
	int isPlaying();
	int isFadingOut();
	
private:
	Mix_Music *music[SB_PLAYLISTMAX];
	//char filepath[255];
	int playing; //-1 means not playing, 1-5 means that playlist number is playing
};

#endif