//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_PHASE_BATTLE_H
#define SB_PHASE_BATTLE_H

#include "sb_GamePhase.h"
#include "sb_ShieldSection.h"
#include "sb_Missile.h"

class sb_Phase_Battle : public sb_GamePhase
{
public:
	sb_Phase_Battle( sb_GamePtr gameToUse );
	~sb_Phase_Battle();
	
	virtual void start();
	virtual void pause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:    
		Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	int totalSeconds;
	int secondsLeft;
	
	int battling;
	int waitingForMissiles;
	Uint32 timeBattleStarted;
	Uint32 timeBattleEnded;
	
	void drawTitle();
	void drawTimer();
	void drawPointer();
	
	sb_Destroyer destroyer;
	
};

#endif