//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_PHASE_NEWWAVE_H
#define SB_PHASE_NEWWAVE_H

#include "sb_GamePhase.h"
#include "sb_GameUtilities.h"

class sb_Phase_NewWave : public sb_GamePhase
{
public:
	sb_Phase_NewWave( sb_GamePtr gameToUse );
	~sb_Phase_NewWave();
	
	virtual void start();
	virtual void pause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:    
	Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	int totalSeconds;
	int secondsLeft;
	
	void drawTitle();
	
	int testingForEnclosure;
	int addingEnemies;
	int showingLevelComplete;
	
	int currentBarge;
	
	int showingTitle;
	Uint32 timeTitleStarted;
	Uint32 timeTitleEnded;
	
	sb_GameUtilities gameUtil;
};

#endif