//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_PHASE_PLACESHIELDS_H
#define SB_PHASE_PLACESHIELDS_H

#include "sb_GamePhase.h"
#include "sb_ShieldSection.h"
#include "sb_GameUtilities.h"

class sb_Phase_PlaceShields : public sb_GamePhase
{
public:
	sb_Phase_PlaceShields( sb_GamePtr gameToUse );
	~sb_Phase_PlaceShields();
	
	virtual void start();
	virtual void pause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:
		
	void drawTitle();
	void drawTimer();

	sb_ShieldSection section;
	sb_ShieldSection sectionNext;
	int nextShape;
	Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	int totalSeconds;
	int secondsLeft;
	
	sb_GameUtilities gameUtil;
};

#endif