//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_PHASE_SETSTAGE_H
#define SB_PHASE_SETSTAGE_H

#include "sb_GamePhase.h"
#include "sb_ShieldSection.h"

class sb_Phase_SetStage : public sb_GamePhase
{
public:
	sb_Phase_SetStage( sb_GamePtr gameToUse );
	~sb_Phase_SetStage();
	
	virtual void start();
	virtual void pause();
	virtual void end();
	virtual void reset();
	virtual void processEvent( SDL_Event &event );
	virtual void animate();
	virtual void draw();
	
private:    
	Uint32 time;
	float titleX, titleY;
	float titleAlpha;
	float titleScaleX, titleScaleY;
	float titleGlow;
	
	int totalSeconds;
	int secondsLeft;
	
	void drawTitle();
	void drawTimer();
	void drawPointer();
	
	int bargesShowing;
	int enemyShowing;
	int waitingForChoice;
	int shieldsBuilding;
	int shieldRow;
	
	sb_point shieldCorner;
	
	int chosenBarge;
	Uint32 timeChoiceStarted;
	Uint32 timeChoiceEnded;
	
	void initStage();
	

};

#endif