//Copyright (c) 2004 Aaron Sullivan. All rights reserved.
#ifndef SB_SHIELDsector_H
#define SB_SHIELDsector_H


#include "SDL.h"
#include "sb_global.h"
#include "sb_ShieldGrid.h"

class sb_ShieldSection
{
public:
	
	void init(sb_ShieldGridPtr relatedShieldGrid);
	void move(float x, float y);
	void reshape(int shapeNumber);
	void animate(Uint32 ticks);
	void rotate(); //begins rotation animation clockwise
	void rotateFinish(); //actually changes the shape so it will place correctly
	void rotateCC(); //counter-clockwise
	void display();
	void displayCursor();
	void displayInGrid();
	void displayAlignedWithGrid();
	int fitIntoGrid();
	void setColor(float red, float green, float blue, float alpha);
	
private:
	sb_ShieldGridPtr shieldGrid;
	float centerX, centerY; //screen coord
	int totalShapes;
	float r, g, b, a;
	float rotation;
	int rotating;
	int rotateCommandQueue;
	
	int sectorSize; //size in pixels of each sector (16 pixels)
	int xSectors; //5 Sectors across
	int ySectors; //5 Sectors down
	int totalSectors; //this will have to match the array below (25)
	sb_SectorType sector[25]; //5x5 grid to hold all possible shapes
	sb_SectorType offendingSector[25]; //5x5 grid to hold parts that didn't fit into shield (for animation purposes)
	float osGlow; //how bright the offendingSector dots show
	
};

typedef sb_ShieldSection* sb_ShieldSectionPtr;

#endif